/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - September 25, 2002 (new file, copied from multiviewsTabs.js).
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

var tabIndex; // added for functions: 
              // loadFolderAsGroup(aFolder);
              // OpenBookmarkFolder(element, datasource, tabCount, tabOpen);
              // OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, tabOpen);

////////////////////////////////////////////////////////////////////////////////
function cleanupForTabGroups(aFolder)
{
  var children = aFolder.childNodes;
  var type;
  // itterate over all menu items
  for (var i = 0; i < children.length; i++) {
    if (children[i].getAttribute("folder")) {
      // we found a bookmark folder so get rid of the bookmark items
      for (i = 0; i < children.length; i++) {
        if (children[i].getAttribute("item"))
          aFolder.removeChild(children[i]);
      }
      // hide 'Open This Folder As Group' and the corresponding separator
      if (!children[0].getAttribute("hidden")) {
        children[0].setAttribute("hidden", "true");
        children[1].setAttribute("hidden", "true");
      }
      break;
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function loadFolderAsGroup(aFolder, aNewWindowFlag)
{
  var children = aFolder.childNodes;
  var newTabs = readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
  var closeRemaining = readMyPref("multizilla.bookmark.close-remaining", "bool", false);
  var newWindows = aNewWindowFlag;
  var tabPanels = getBrowser().mPanelContainer.childNodes;
  var tabCount = tabPanels.length;
  var dupFound = 0;
  var url;

  if (newTabs == 2) {
    window.openDialog("chrome://multiviews/content/multiviewsAskSettings.xul", "_blank", "chrome,modal,centerscreen", getBrowser(), closeRemaining);
    newTabs = gBrowser.mNewTabs;
    closeRemaining = gBrowser.mRemoveRemaining;
    if (gBrowser.mNewTabs == -1)
      return;
  }
  newTabs = (newTabs == 1) ? true : false;
  var startTab = newTabs ? tabCount : 0;
  // menu item[0/1/2] are extra items
  // menu item[3] is our menuseparator
  tabIndex = 0;
  gBrowser = getBrowser();
  for (var i = 4; i < children.length; i++) {
    url = children[i].getAttribute("url");
    if (children[i].getAttribute("container") == "true") {
      OpenBookmarkFolder(children[i], document.getElementById('BookmarksMenu').database, tabCount, newTabs, newWindows, true);
    }
    else if (url) {
      if (newWindows) {
        window.open(url);
      } 
      else if (!preventDupeTab(url)) {
        if (!newTabs && tabIndex < tabCount) {
          var browser = gBrowser.getBrowserForTab(gBrowser.mTabList[tabIndex]);
          browser.loadURI(url, null, nsIWebNavigation.LOAD_FLAGS_NONE);
        }
        else
          gBrowser.addTab(url, null);
        tabIndex++;
      }
      else dupFound++;
    }
  }
  // Select the first tab in the group.
  if (!newWindows /* && tabIndex */)
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];
  if (!newWindows && closeRemaining) {
    if (newTabs) {
      /* startTab = gBrowser.mTabList[startTab].ordinal-1;
      for (i = startTab; i >= 0; i--)
        gBrowser.removeTab(gBrowser.mTabList[i]); */
    }
    else if (dupFound == 0) {
      for (i = tabCount-1; i >= tabIndex; i--)
        gBrowser.removeTab(gBrowser.mTabList[i]);
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function opens a bookmark folder, it is a modified copy of
// OpenBookmarkGroup(element, datasource) in navigator.js
////////////////////////////////////////////////////////////////////////////////
function OpenBookmarkFolder(element, datasource, tabCount, newTabs, newWindows, isChild)
{
  if (!datasource)
    return;
  var id = element.getAttribute("id");
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
  var resource = rdf.GetResource(id, true);
  OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild);
}
////////////////////////////////////////////////////////////////////////////////
// this function opens nested bookmark folders in a new tabs, it is a modified 
// copy of OpenBookmarkGroupFromResource(element, datasource) in navigator.js
////////////////////////////////////////////////////////////////////////////////
function OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild)
{
  var urlResource = rdf.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var tabPanels = gBrowser.mPanelContainer.childNodes;
  tabIndex = 0;

  while (containerChildren.hasMoreElements()) {
    resource = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(resource, urlResource, true);
    if (target) {
      var uri = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

      if (newWindows) {
        window.open(uri);
      } 
      else  if (!preventDupeTab(uri)) {
        if (!isChild && !newTabs && tabIndex < tabCount) {
          var browser = gBrowser.getBrowserForTab(gBrowser.mTabList[tabIndex]);
          browser.loadURI(uri, null, nsIWebNavigation.LOAD_FLAGS_NONE);
        }
        else
          gBrowser.addTab(uri, null);
        tabIndex++;
      }
    }
    else OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild);
  }
}
////////////////////////////////////////////////////////////////////////////////
function setStartupGroupmark(bookmarkID)
{
  writePref("string", "multizilla.tabs.groupmark", bookmarkID);
  writePref("int", "browser.startup.page", 3);
}
////////////////////////////////////////////////////////////////////////////////
function setStartupBookmark(url)
{
  writePref("string", "browser.startup.homepage", url);
  writePref("int", "browser.startup.page", 1);
}
////////////////////////////////////////////////////////////////////////////////
function refreshBookmarkMenuPopup(aParent, aPrefIdentifier)
{
  if (!aParent || !aPrefIdentifier)
    return;
  var menu = aParent;
  var menuItems = menu.childNodes.length;
  var prefValue = Number(readMyPref(aPrefIdentifier, "int", 0));

  if (aPrefIdentifier == "multizilla.bookmark.items") {
    menu.childNodes[0].setAttribute("hidden", (prefValue & 1) ? "false" : "true");
    menu.childNodes[1].setAttribute("hidden", (prefValue & 2) ? "false" : "true");
    menu.childNodes[2].setAttribute("hidden", (prefValue & 4) ? "false" : "true");
  }
  else if (menuItems > 5) {
    menu.firstChild.setAttribute('hidden', 'true');
    menu.childNodes[1].setAttribute("hidden", (prefValue & 1) ? "false" : "true");
    menu.childNodes[2].setAttribute("hidden", (prefValue & 2) ? "false" : "true");
    menu.childNodes[3].setAttribute("hidden", (prefValue & 4) ? "false" : "true");
    menu.childNodes[4].setAttribute("hidden", (prefValue & 7) ? "false" : "true");
  }
  if (menuItems == 5 || menuItems == 6 && menu.childNodes[5].localName == "menuitem") {
    menu.childNodes[1].setAttribute("hidden", "true");
    menu.childNodes[2].setAttribute("hidden", "true");
    menu.childNodes[3].setAttribute("hidden", "true");
    menu.childNodes[4].setAttribute("hidden", "true");
  }
}
////////////////////////////////////////////////////////////////////////////////
function initializeBookmarksTemplate()
{
  var mzPlainItem  = document.getElementById('mzPlainItem');
  var mzPlainFolder = document.getElementById('mzPlainFolder');
  var mzPlainGroup = document.getElementById('mzPlainGroup');

  var prefValue = readMyPref("multizilla.bookmark.items", "int", 8);
  if (prefValue && prefValue != 8)
    mzPlainItem.setAttribute("disabled", "true");

  prefValue = readMyPref("multizilla.bookmark.folders", "int", 11);
  if (prefValue && prefValue != 8)
    mzPlainFolder.setAttribute("disabled", "true");

  prefValue = readMyPref("multizilla.bookmark.groups", "int", 11);
  if (prefValue && prefValue != 8)
    mzPlainGroup.setAttribute("disabled", "true");
}
////////////////////////////////////////////////////////////////////////////////
function initializePersonalToolbarTemplate()
{
  var mzPTPlainItem  = document.getElementById('mzPTPlainItem');
  var mzPTPlainFolder = document.getElementById('mzPTPlainFolder');
  var mzPTPlainGroup = document.getElementById('mzPTPlainGroup');

  var mzPTBPlainFolder = document.getElementById('mzPTBPlainFolder');
  var mzPTBPlainGroup = document.getElementById('mzPTBPlainGroup');

  var prefValue = readMyPref("multizilla.bookmark.items", "int", 8);
  if (prefValue && !(prefValue & 8))
    mzPTPlainItem.setAttribute("disabled", "true");
  prefValue = readMyPref("multizilla.bookmark.folders", "int", 11);
  if (prefValue && !(prefValue & 8)) {
    mzPTPlainFolder.setAttribute("disabled", "true");
    mzPTBPlainFolder.setAttribute("disabled", "true");
  }
  prefValue = readMyPref("multizilla.bookmark.groups", "int", 11);
  if (prefValue && !(prefValue & 8)) {
    mzPTPlainGroup.setAttribute("disabled", "true");
    mzPTBPlainGroup.setAttribute("disabled", "true");
  }
}
